


<h1><a name="ruby" id="ruby">Ruby</a></h1>
<div class="level1">

<p>

<a href="http://www.ruby-lang.org" class="urlextern" title="http://www.ruby-lang.org"  rel="nofollow">Ruby</a>: <a href="http://en.wikipedia.org/wiki/Ruby_%28programming_language%29" class="interwiki iw_wp" title="http://en.wikipedia.org/wiki/Ruby_%28programming_language%29">Ruby</a>
</p>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Ruby" [1-102] -->
<h2><a name="how_to_process_a_file_with_a_list_of_numbers" id="how_to_process_a_file_with_a_list_of_numbers">How to process a file with a list of numbers</a></h2>
<div class="level2">
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=main:ruby&amp;codeblock=0" title="Download Snippet" class="mediafile mf_rb">calc.rb</a></dt>
<dd><pre class="code file ruby"><span class="co1">#!/usr/bin/ruby</span>
lines = <span class="kw4">IO</span>.<span class="me1">read</span><span class="br0">&#40;</span>ARGV<span class="br0">&#91;</span>0<span class="br0">&#93;</span><span class="br0">&#41;</span>.<span class="kw3">split</span><span class="br0">&#40;</span><span class="st0">&quot;<span class="es0">\n</span>&quot;</span><span class="br0">&#41;</span>;
min = lines.<span class="me1">inject</span><span class="br0">&#123;</span> <span class="sy0">|</span>x, y<span class="sy0">|</span> <span class="br0">&#91;</span>x.<span class="me1">to_i</span>, y.<span class="me1">to_i</span><span class="br0">&#93;</span>.<span class="me1">min</span> <span class="br0">&#125;</span>
max = lines.<span class="me1">inject</span><span class="br0">&#123;</span> <span class="sy0">|</span>x, y<span class="sy0">|</span> <span class="br0">&#91;</span>x.<span class="me1">to_i</span>, y.<span class="me1">to_i</span><span class="br0">&#93;</span>.<span class="me1">max</span> <span class="br0">&#125;</span>
media = lines.<span class="me1">inject</span><span class="br0">&#123;</span> <span class="sy0">|</span>x, y<span class="sy0">|</span> x.<span class="me1">to_i</span> <span class="sy0">+</span> y.<span class="me1">to_i</span> <span class="br0">&#125;</span>.<span class="me1">to_f</span> <span class="sy0">/</span> lines.<span class="me1">size</span>;
desvio = <span class="kw4">Math</span>.<span class="me1">sqrt</span><span class="br0">&#40;</span>lines.<span class="me1">inject</span><span class="br0">&#40;</span>0<span class="br0">&#41;</span><span class="br0">&#123;</span> <span class="sy0">|</span>x, y<span class="sy0">|</span> x.<span class="me1">to_i</span> <span class="sy0">+</span> <span class="br0">&#40;</span>y.<span class="me1">to_i</span> <span class="sy0">-</span> media<span class="br0">&#41;</span> <span class="sy0">**</span> 2 <span class="br0">&#125;</span> <span class="sy0">/</span> <span class="br0">&#40;</span>lines.<span class="me1">size</span> <span class="sy0">-</span> 1<span class="br0">&#41;</span><span class="br0">&#41;</span>
coef = 2.262 <span class="sy0">*</span> desvio <span class="sy0">/</span> <span class="kw4">Math</span>.<span class="me1">sqrt</span><span class="br0">&#40;</span>lines.<span class="me1">size</span><span class="br0">&#41;</span>
<span class="co1">#print sprintf(&quot;  &amp; %i &amp; %i &amp; %0.2f &amp; %0.2f \\\\\n&quot;, min, max, media, desvio)</span>
<span class="kw3">print</span> <span class="kw3">sprintf</span><span class="br0">&#40;</span><span class="st0">&quot;  &amp; %0.2f &amp; %0.2f &amp; [%0.2f, %0.2f] <span class="es0">\\</span><span class="es0">\\</span><span class="es0">\n</span>&quot;</span>, media, desvio, media <span class="sy0">-</span> coef, media <span class="sy0">+</span> coef<span class="br0">&#41;</span></pre>
</dd></dl>
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=main:ruby&amp;codeblock=1" title="Download Snippet" class="mediafile mf_in">calc.in</a></dt>
<dd><pre class="code file text">10
20
15</pre>
</dd></dl>
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=main:ruby&amp;codeblock=2" title="Download Snippet" class="mediafile mf_out">calc.out</a></dt>
<dd><pre class="code file text">  &amp; 99.99 &amp; 99.99 &amp; [99.99, 99.99] \\</pre>
</dd></dl>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "How to process a file with a list of numbers" [103-837] -->
<h2><a name="how_to_process_a_list_of_names" id="how_to_process_a_list_of_names">How to process a list of names</a></h2>
<div class="level2">
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=main:ruby&amp;codeblock=3" title="Download Snippet" class="mediafile mf_rb">figure.rb</a></dt>
<dd><pre class="code file ruby"><span class="co1">#!/usr/bin/ruby</span>
lines = <span class="kw4">IO</span>.<span class="me1">read</span><span class="br0">&#40;</span>ARGV<span class="br0">&#91;</span>0<span class="br0">&#93;</span><span class="br0">&#41;</span>.<span class="kw3">gsub</span><span class="br0">&#40;</span><span class="sy0">/</span>.<span class="sy0">*</span>\<span class="sy0">*</span>.<span class="sy0">*</span>\n<span class="sy0">/</span>, <span class="st0">''</span><span class="br0">&#41;</span>.<span class="kw3">gsub</span><span class="br0">&#40;</span><span class="sy0">/</span> \<span class="br0">&#40;</span>.\<span class="br0">&#41;</span><span class="sy0">/</span>, <span class="st0">''</span><span class="br0">&#41;</span>.<span class="kw3">split</span><span class="br0">&#40;</span><span class="st0">&quot;<span class="es0">\n</span>&quot;</span><span class="br0">&#41;</span>;
lines.<span class="me1">each</span> <span class="br0">&#123;</span> <span class="sy0">|</span>line<span class="sy0">|</span>
	<span class="co1">#print line + &quot;\n&quot;</span>
	line.<span class="kw3">split</span><span class="br0">&#40;</span><span class="st0">' '</span><span class="br0">&#41;</span>.<span class="me1">join</span>.<span class="me1">each</span> <span class="br0">&#123;</span> <span class="sy0">|</span>word<span class="sy0">|</span>
<span class="kw3">print</span> <span class="st0">'<span class="es0">\b</span>egin{figure}[!h]
<span class="es0">\c</span>entering
<span class="es0">\i</span>ncludegraphics[scale=0.42]{'</span>
		<span class="kw3">print</span> word <span class="sy0">+</span> <span class="st0">&quot;.jpg&quot;</span>
	<span class="kw3">system</span><span class="br0">&#40;</span><span class="st0">&quot;touch &quot;</span> <span class="sy0">+</span> word <span class="sy0">+</span> <span class="st0">&quot;.jpg&quot;</span><span class="br0">&#41;</span>	
<span class="kw3">print</span> <span class="st0">'}
<span class="es0">\c</span>aption{'</span>
		<span class="kw3">print</span> <span class="st0">&quot;Diagrama de Interação: &quot;</span> <span class="sy0">+</span> line
<span class="kw3">print</span> <span class="st0">'}
<span class="es0">\e</span>nd{figure}
'</span>
	<span class="kw3">print</span> <span class="st0">&quot;<span class="es0">\n</span><span class="es0">\n</span>&quot;</span>
	<span class="br0">&#125;</span>
<span class="br0">&#125;</span></pre>
</dd></dl>

<p>
Removing accents:
</p>
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=main:ruby&amp;codeblock=4" title="Download Snippet" class="mediafile mf_rb">figure2.rb</a></dt>
<dd><pre class="code file ruby"><span class="co1">#!/usr/bin/ruby</span>
lines = <span class="kw4">IO</span>.<span class="me1">read</span><span class="br0">&#40;</span>ARGV<span class="br0">&#91;</span>1<span class="br0">&#93;</span><span class="br0">&#41;</span>.<span class="kw3">gsub</span><span class="br0">&#40;</span><span class="sy0">/</span>.<span class="sy0">*</span>\<span class="sy0">*</span>.<span class="sy0">*</span>\n<span class="sy0">/</span>, <span class="st0">''</span><span class="br0">&#41;</span>.<span class="kw3">gsub</span><span class="br0">&#40;</span><span class="sy0">/</span> \<span class="br0">&#40;</span>.\<span class="br0">&#41;</span><span class="sy0">/</span>, <span class="st0">''</span><span class="br0">&#41;</span>.<span class="kw3">split</span><span class="br0">&#40;</span><span class="st0">&quot;<span class="es0">\n</span>&quot;</span><span class="br0">&#41;</span>;
lines2 = <span class="kw4">IO</span>.<span class="me1">read</span><span class="br0">&#40;</span>ARGV<span class="br0">&#91;</span>0<span class="br0">&#93;</span><span class="br0">&#41;</span>.<span class="kw3">gsub</span><span class="br0">&#40;</span><span class="sy0">/</span>.<span class="sy0">*</span>\<span class="sy0">*</span>.<span class="sy0">*</span>\n<span class="sy0">/</span>, <span class="st0">''</span><span class="br0">&#41;</span>.<span class="kw3">gsub</span><span class="br0">&#40;</span><span class="sy0">/</span> \<span class="br0">&#40;</span>.\<span class="br0">&#41;</span><span class="sy0">/</span>, <span class="st0">''</span><span class="br0">&#41;</span>.<span class="kw3">split</span><span class="br0">&#40;</span><span class="st0">&quot;<span class="es0">\n</span>&quot;</span><span class="br0">&#41;</span>;
i = <span class="nu0">0</span>;
lines.<span class="me1">each_with_index</span> <span class="br0">&#123;</span> <span class="sy0">|</span>line, index<span class="sy0">|</span>
	i = i <span class="sy0">+</span> <span class="nu0">1</span>;
	<span class="co1">#print line + &quot;\n&quot;</span>
	line.<span class="kw3">split</span><span class="br0">&#40;</span><span class="st0">' '</span><span class="br0">&#41;</span>.<span class="me1">join</span>.<span class="me1">each</span> <span class="br0">&#123;</span> <span class="sy0">|</span>word<span class="sy0">|</span>
<span class="kw3">print</span> <span class="st0">'<span class="es0">\b</span>egin{figure}[htbp]
<span class="es0">\c</span>entering
<span class="es0">\i</span>ncludegraphics[scale=0.42]{'</span>
		<span class="kw3">print</span> word <span class="sy0">+</span> <span class="st0">&quot;.jpg&quot;</span>
	<span class="co1">#system(&quot;touch &quot; + word + &quot;.jpg&quot;)	</span>
	<span class="co1">#system(&quot;cp int.jpg &quot; + word + &quot;.jpg&quot;)</span>
<span class="kw3">print</span> <span class="st0">'}
<span class="es0">\c</span>aption{'</span>
		<span class="kw3">print</span> <span class="st0">&quot;Diagrama de Interação: &quot;</span> <span class="sy0">+</span> lines2<span class="br0">&#91;</span>index<span class="br0">&#93;</span>
<span class="kw3">print</span> <span class="st0">'}
<span class="es0">\e</span>nd{figure}
'</span>
	<span class="kw3">print</span> <span class="st0">&quot;<span class="es0">\n</span><span class="es0">\n</span>&quot;</span>
	<span class="kw1">if</span> i <span class="sy0">%</span> 10 == 0 <span class="kw1">then</span>
		<span class="kw3">print</span> <span class="st0">&quot;<span class="es0">\\</span>clearpage<span class="es0">\n</span><span class="es0">\n</span>&quot;</span>
	<span class="kw1">end</span>
	<span class="br0">&#125;</span>
<span class="br0">&#125;</span></pre>
</dd></dl>
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=main:ruby&amp;codeblock=5" title="Download Snippet" class="mediafile mf_in">figure.in</a></dt>
<dd><pre class="code file text">	*
Consultar Usuário (M)
	*
Inicializar Sistema (F)</pre>
</dd></dl>
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=main:ruby&amp;codeblock=6" title="Download Snippet" class="mediafile mf_out">figure.out</a></dt>
<dd><pre class="code file latex"><span class="re8">\begin</span><span class="sy0">{</span><span class="re9"><span class="re7">figure</span></span><span class="sy0">}[</span><span class="re2">!h</span><span class="sy0">]</span>
<span class="sy0">\</span><a href="http://www.golatex.de/wiki/index.php?title=%5Ccentering"><span class="kw1">centering</span></a>
<span class="sy0">\</span><a href="http://www.golatex.de/wiki/index.php?title=%5Cincludegraphics"><span class="kw1">includegraphics</span></a><span class="sy0">[</span><span class="re2">scale=0.42</span><span class="sy0">]{</span><span class="re9">ConsultarUsuario.jpg</span><span class="sy0">}</span>
<span class="sy0">\</span><a href="http://www.golatex.de/wiki/index.php?title=%5Ccaption"><span class="kw1">caption</span></a><span class="sy0">{</span><span class="re9">Diagrama de Interação: Consultar Usuário</span><span class="sy0">}</span>
<span class="re8">\end</span><span class="sy0">{</span><span class="re9"><span class="re7">figure</span></span><span class="sy0">}</span>
&nbsp;
&nbsp;
<span class="re8">\begin</span><span class="sy0">{</span><span class="re9"><span class="re7">figure</span></span><span class="sy0">}[</span><span class="re2">!h</span><span class="sy0">]</span>
<span class="sy0">\</span><a href="http://www.golatex.de/wiki/index.php?title=%5Ccentering"><span class="kw1">centering</span></a>
<span class="sy0">\</span><a href="http://www.golatex.de/wiki/index.php?title=%5Cincludegraphics"><span class="kw1">includegraphics</span></a><span class="sy0">[</span><span class="re2">scale=0.42</span><span class="sy0">]{</span><span class="re9">InicializarSistema.jpg</span><span class="sy0">}</span>
<span class="sy0">\</span><a href="http://www.golatex.de/wiki/index.php?title=%5Ccaption"><span class="kw1">caption</span></a><span class="sy0">{</span><span class="re9">Diagrama de Interação: Inicializar Sistema</span><span class="sy0">}</span>
<span class="re8">\end</span><span class="sy0">{</span><span class="re9"><span class="re7">figure</span></span><span class="sy0">}</span></pre>
</dd></dl>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "How to process a list of names" [838-2403] -->
<h2><a name="examples" id="examples">Examples</a></h2>
<div class="level2">
<pre class="code ruby">sum = <span class="nu0">0.0</span>; 10.<span class="me1">times</span><span class="br0">&#123;</span> <span class="sy0">|</span>i<span class="sy0">|</span> sum <span class="sy0">+</span>= <span class="kw4">IO</span>.<span class="me1">read</span><span class="br0">&#40;</span><span class="st0">&quot;#{i+1}.out&quot;</span><span class="br0">&#41;</span>.<span class="kw3">split</span><span class="br0">&#40;</span><span class="st0">&quot;<span class="es0">\n</span>&quot;</span><span class="br0">&#41;</span><span class="br0">&#91;</span>5<span class="br0">&#93;</span>.<span class="kw3">split</span><span class="br0">&#40;</span><span class="br0">&#41;</span><span class="br0">&#91;</span>0<span class="br0">&#93;</span>.<span class="me1">to_i</span> <span class="br0">&#125;</span>; <span class="kw3">print</span> sum <span class="sy0">/</span> <span class="nu0">10</span></pre>
<pre class="code ruby">10.<span class="me1">times</span><span class="br0">&#123;</span> <span class="sy0">|</span>i<span class="sy0">|</span> <span class="kw3">print</span> <span class="kw4">IO</span>.<span class="me1">read</span><span class="br0">&#40;</span><span class="st0">&quot;#{i+1}.out&quot;</span><span class="br0">&#41;</span>.<span class="kw3">split</span><span class="br0">&#40;</span><span class="st0">&quot;<span class="es0">\n</span>&quot;</span><span class="br0">&#41;</span><span class="br0">&#91;</span>5<span class="br0">&#93;</span>.<span class="kw3">split</span><span class="br0">&#40;</span><span class="br0">&#41;</span><span class="br0">&#91;</span><span class="nu0">0</span><span class="br0">&#93;</span> <span class="sy0">+</span> <span class="st0">&quot;<span class="es0">\n</span>&quot;</span> <span class="br0">&#125;</span></pre>
<pre class="code ruby"><span class="kw3">require</span> <span class="st0">&quot;net/http&quot;</span>
<span class="re2">Net::HTTP</span>.<span class="me1">new</span><span class="br0">&#40;</span><span class="st0">&quot;verdi.softwarelivre.org&quot;</span>, <span class="nu0">80</span><span class="br0">&#41;</span>.<span class="me1">get</span><span class="br0">&#40;</span><span class="st0">&quot;http://verdi.softwarelivre.org/papers_ng/swiss/get?token=4E0C4F2EC6B29562&quot;</span><span class="br0">&#41;</span>.<span class="me1">body</span>.<span class="me1">to_s</span></pre>
<pre class="code ruby"><span class="st0">&quot;4E0C4F2EC6B29599&quot;</span>.<span class="me1">to_i</span><span class="br0">&#40;</span><span class="nu0">16</span><span class="br0">&#41;</span>.<span class="me1">succ</span>.<span class="me1">to_s</span><span class="br0">&#40;</span><span class="nu0">16</span><span class="br0">&#41;</span>.<span class="me1">upcase</span></pre>
<pre class="code ruby">5.<span class="me1">times</span> <span class="br0">&#123;</span> <span class="kw3">print</span> <span class="st0">&quot;s:#{s = s.to_i(16).succ.to_s(16).upcase}<span class="es0">\n</span>&quot;</span> <span class="br0">&#125;</span></pre>
<dl class="code">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=main:ruby&amp;codeblock=12" title="Download Snippet" class="mediafile mf_rb">fisl.rb</a></dt>
<dd><pre class="code ruby"><span class="co1">#!/usr/bin/ruby</span>
<span class="kw3">require</span> <span class="st0">&quot;net/http&quot;</span>
s = <span class="st0">&quot;4E0C4F2EC6B29561&quot;</span>
1000000.<span class="me1">times</span> <span class="br0">&#123;</span>
	<span class="kw3">p</span> = <span class="re2">Net::HTTP</span>.<span class="me1">new</span><span class="br0">&#40;</span><span class="st0">&quot;verdi.softwarelivre.org&quot;</span>, <span class="nu0">80</span><span class="br0">&#41;</span>.<span class="me1">get</span><span class="br0">&#40;</span><span class="st0">&quot;http://verdi.softwarelivre.org/papers_ng/swiss/get?token=#{s = s.to_i(16).succ.to_s(16).upcase}&quot;</span><span class="br0">&#41;</span>.<span class="me1">body</span>.<span class="me1">to_s</span>
	<span class="co1">#print s + &quot;\n\n&quot;</span>
	<span class="co1">#print p + &quot;\n\n&quot;</span>
	<span class="kw3">print</span> s <span class="sy0">+</span> <span class="st0">&quot; depleted<span class="es0">\n</span>&quot;</span> <span class="kw1">if</span> !<span class="kw3">p</span>.<span class="me1">match</span><span class="br0">&#40;</span><span class="st0">&quot;DepletedToken&quot;</span><span class="br0">&#41;</span>.<span class="kw2">nil</span>?
	<span class="kw3">print</span> s <span class="sy0">+</span> <span class="st0">&quot; doesn't exist<span class="es0">\n</span>&quot;</span> <span class="kw1">if</span> !<span class="kw3">p</span>.<span class="me1">match</span><span class="br0">&#40;</span><span class="st0">&quot;DoesNotExist&quot;</span><span class="br0">&#41;</span>.<span class="kw2">nil</span>?
	<span class="kw3">print</span> s <span class="sy0">+</span> <span class="st0">&quot; good?<span class="es0">\n</span>&quot;</span> <span class="kw1">if</span> <span class="kw3">p</span>.<span class="me1">match</span><span class="br0">&#40;</span><span class="st0">&quot;DepletedToken&quot;</span><span class="br0">&#41;</span>.<span class="kw2">nil</span>? <span class="sy0">&amp;&amp;</span> <span class="kw3">p</span>.<span class="me1">match</span><span class="br0">&#40;</span><span class="st0">&quot;DoesNotExist&quot;</span><span class="br0">&#41;</span>.<span class="kw2">nil</span>?
<span class="br0">&#125;</span></pre>
</dd></dl>
<pre class="code ruby"><span class="kw3">rand</span><span class="br0">&#40;</span><span class="st0">&quot;10000000000000000&quot;</span>.<span class="me1">to_i</span><span class="br0">&#40;</span><span class="nu0">16</span><span class="br0">&#41;</span><span class="br0">&#41;</span>.<span class="me1">to_s</span><span class="br0">&#40;</span><span class="nu0">16</span><span class="br0">&#41;</span>.<span class="me1">upcase</span></pre>
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=main:ruby&amp;codeblock=14" title="Download Snippet" class="mediafile mf_rb">fisl2.rb</a></dt>
<dd><pre class="code file ruby"><span class="co1">#!/usr/bin/ruby</span>
<span class="kw3">require</span> <span class="st0">&quot;net/http&quot;</span>
1000000.<span class="me1">times</span> <span class="br0">&#123;</span>
	<span class="kw3">p</span> = <span class="re2">Net::HTTP</span>.<span class="me1">new</span><span class="br0">&#40;</span><span class="st0">&quot;verdi.softwarelivre.org&quot;</span>, <span class="nu0">80</span><span class="br0">&#41;</span>.<span class="me1">get</span><span class="br0">&#40;</span><span class="st0">&quot;http://verdi.softwarelivre.org/papers_ng/swiss/get?token=#{s = rand(&quot;</span><span class="nu0">10000000000000000</span><span class="st0">&quot;.to_i(16)).to_s(16).upcase}&quot;</span><span class="br0">&#41;</span>.<span class="me1">body</span>.<span class="me1">to_s</span>
	<span class="co1">#print s + &quot;\n\n&quot;</span>
	<span class="co1">#print p + &quot;\n\n&quot;</span>
	<span class="kw3">print</span> s <span class="sy0">+</span> <span class="st0">&quot; depleted<span class="es0">\n</span>&quot;</span> <span class="kw1">if</span> !<span class="kw3">p</span>.<span class="me1">match</span><span class="br0">&#40;</span><span class="st0">&quot;DepletedToken&quot;</span><span class="br0">&#41;</span>.<span class="kw2">nil</span>?
	<span class="kw3">print</span> s <span class="sy0">+</span> <span class="st0">&quot; doesn't exist<span class="es0">\n</span>&quot;</span> <span class="kw1">if</span> !<span class="kw3">p</span>.<span class="me1">match</span><span class="br0">&#40;</span><span class="st0">&quot;DoesNotExist&quot;</span><span class="br0">&#41;</span>.<span class="kw2">nil</span>? <span class="sy0">&amp;&amp;</span> s.<span class="me1">to_i</span><span class="br0">&#40;</span>16<span class="br0">&#41;</span> <span class="sy0">%</span> 1000 == 0
	<span class="kw3">print</span> s <span class="sy0">+</span> <span class="st0">&quot; good?<span class="es0">\n</span>&quot;</span> <span class="kw1">if</span> <span class="kw3">p</span>.<span class="me1">match</span><span class="br0">&#40;</span><span class="st0">&quot;DepletedToken&quot;</span><span class="br0">&#41;</span>.<span class="kw2">nil</span>? <span class="sy0">&amp;&amp;</span> <span class="kw3">p</span>.<span class="me1">match</span><span class="br0">&#40;</span><span class="st0">&quot;DoesNotExist&quot;</span><span class="br0">&#41;</span>.<span class="kw2">nil</span>?
<span class="br0">&#125;</span></pre>
</dd></dl>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Examples" [2404-] -->